Attribute VB_Name = "modLevel"
Option Explicit

Public Sub LoadLevel(lvl As Long)
    On Error GoTo errH
    
    Dim sFile   As String
    Dim ff      As Integer
    Dim lev     As LEVELFORMAT
    Dim k       As Long
    
    sFile = BuildPath(App.path, "\levels\level" & Right$("000" & lvl, 3) & ".bbl")
    
    If Dir(sFile) = vbNullString Then
        MsgBox "Cannot load level! File:" & vbNewLine & sFile & vbNewLine & _
               "is missing! Please reinstall game.", vbCritical, "Brick ball"
        Quit
    End If
    
    ff = FreeFile
    Open sFile For Binary As #ff
        Get #ff, 1, lev
    Close #ff

    Bricks = lev.lBricks
    MetalBricks = lev.lMetal
    BricksLeft = Bricks
    ReDim Brick(1 To Bricks)

    For k = 1 To Bricks
        Brick(k).Bonus = BONUS_NONE
        Brick(k).Frame = 0
        Brick(k).H = lev.lH(k)
        Brick(k).Style = lev.lType(k)
        Brick(k).W = lev.lW(k)
        Brick(k).X = lev.lX(k)
        Brick(k).Y = lev.lY(k)
    Next
    
    Exit Sub
errH:
    MsgBox "Error loading level!", vbCritical, "Brick Ball"
End Sub
