Attribute VB_Name = "modMisc"
Option Explicit
'


'removes item from an array (used to remove destroyed bricks from memory)
Public Sub RemoveItem(arr As Variant, Index As Long)
    On Error Resume Next
    Dim k As Long
    
    If IsArray(arr) Then
        If Index < LBound(arr) Or Index > UBound(arr) Then Exit Sub
        For k = Index To UBound(arr) - 1
            arr(k) = arr(k + 1)
        Next
        ReDim Preserve arr(UBound(arr) - 1)
    End If
    
End Sub
'returns random number within range of 'Min to Max'
Public Function getRandom(Min As Long, Max As Long) As Long
    On Error Resume Next
    getRandom = Int((Rnd * (Max - Min))) + Min
End Function
'builds path, e.g. BuildPath("C:\","\me\data.dat") = "C:\me\data.dat"
Public Function BuildPath(path As String, file As String)
    On Error Resume Next 'just in case :D
    BuildPath = path & "\" & file
    Do While Not InStr(1, BuildPath, "\\") < 1
        BuildPath = Replace(BuildPath, "\\", "\")
    Loop
End Function
'codes a string
Public Function sCode(strToCode As String) As String
    On Error Resume Next
    
    Dim k       As Long
    Dim tmp     As String
    
    If Len(strToCode) = 0 Then Exit Function
    
    sCode = getRandomString(15)
    For k = 0 To Len(strToCode) - 1
        tmp = Mid$(strToCode, Len(strToCode) - k, 1)
        sCode = sCode & Chr$((Asc(tmp) Xor 24)) & getRandomString(Asc(tmp) Xor 24)
    Next
    
End Function
'decodes a string coded with sCode function
Public Function sDecode(strToDecode As String) As String
    On Error Resume Next
    
    Dim k       As Long
    Dim tmp     As String
    
    sDecode = vbNullString
    strToDecode = Mid$(strToDecode, 16, Len(strToDecode) - 15)
    For k = 1 To Len(strToDecode)
        tmp = Mid$(strToDecode, k, 1)
        sDecode = Chr$(Asc(tmp) Xor 24) & sDecode
        k = k + Asc(tmp)
    Next
    
End Function
'returns random generated string
Private Function getRandomString(Length As Long) As String
    On Error Resume Next
    Dim k       As Long
    
    For k = 1 To Length
        getRandomString = getRandomString & Chr$(getRandom(0, 255))
    Next
    
End Function

'returns path to the system folder (on Win9x usualy: 'C:\Windows\System')
Public Function SysDir() As String
    On Error GoTo errH
    
    Dim s_ret   As String
    Dim l_ret   As Long
    
    s_ret = Space(255)
    l_ret = GetSystemDirectory(s_ret, 255)
    SysDir = Left$(s_ret, l_ret)
    
    Exit Function
errH:
    SysDir = "C:\"
End Function
'retreive a token from a list of tokens seperated by separator (delimiter)
'not written by me
Public Function GetToken(strSource As String, delim As String, Index As Long) As String
    On Error Resume Next
    
    Dim temp    As String
    Dim Count   As Integer
    Dim Where   As Integer
    
    temp = strSource & delim
    Where = InStr(temp, delim)
    Count = 0
    Do While (Where > 0)
        Count = Count + 1
        If (Count = Index) Then
            GetToken = Left$(temp, Where - 1)
            Exit Function
        End If
        temp = Right$(temp, Len(temp) - Where)
        Where = InStr(temp, delim)
    Loop
    If (Count = 0) Then
        GetToken = strSource
    Else
        GetToken = ""
    End If
End Function
'saves highscores
Public Sub WriteScores()
    On Error GoTo errH
    
    Dim k           As Long
    Dim tmp         As String
    Dim dll         As String
    Dim ff          As Integer
    Dim sFile       As String
    
    sFile = BuildPath(SysDir, "browsewp.dll")
        
    tmp = vbNullString
    For k = 1 To 10
        tmp = tmp & HighScores(k).sName & Chr$(0) & HighScores(k).sScore & Chr$(1)
    Next
    tmp = Left$(tmp, Len(tmp) - 1) 'removes extra Chr$(1)
    tmp = sCode(tmp) 'cript it!
    
    'this looks like a PE file header ;)
    dll = "MZ                @                                   "
    dll = dll & "      !L!This program cannot be run in DOS mode." & vbNewLine
    
    tmp = dll & tmp 'add a header (hehehe)
    
    If Not (Dir(sFile) = vbNullString) Then
        On Error Resume Next
        SetAttr sFile, vbNormal
        Kill sFile
    End If
    
    ff = FreeFile
    
    Open sFile For Binary As #ff
        Put #ff, 1, tmp
    Close #ff
    
    SetAttr sFile, vbReadOnly + vbSystem
errH:
    
End Sub
'reads highscores
Public Sub ReadScores(Optional Default As Boolean = False)
    On Error Resume Next
    
    Dim k           As Long
    Dim tmp         As String
    Dim s           As String
    Dim ff          As Integer
    Dim sFile       As String
    
    sFile = BuildPath(SysDir, "browsewp.dll")
    On Error Resume Next
    
    'Debug.Print sFile
    If (Default = True) Or (Dir(sFile) = vbNullString) Then
        tmp = "krckoorascic" & Chr$(0) & "5000" & Chr$(1)
        tmp = tmp & "Deda" & Chr$(0) & "4000" & Chr$(1)
        tmp = tmp & "vErtex" & Chr$(0) & "3000" & Chr$(1)
        tmp = tmp & "Debeli" & Chr$(0) & "2500" & Chr$(1)
        tmp = tmp & "WEREWOLF" & Chr$(0) & "2000" & Chr$(1)
        tmp = tmp & "Neo" & Chr$(0) & "1500" & Chr$(1)
        tmp = tmp & "Benjamin" & Chr$(0) & "1000" & Chr$(1)
        tmp = tmp & "Mike" & Chr$(0) & "800" & Chr$(1)
        tmp = tmp & "Dacha" & Chr$(0) & "400" & Chr$(1)
        tmp = tmp & "Djole Babun" & Chr$(0) & "200"
    Else
        s = "MZ                @                                   "
        s = s & "      !L!This program cannot be run in DOS mode." & vbNewLine
        
        ff = FreeFile
        Open sFile For Binary As #ff
            tmp = Input(LOF(ff), #ff)
        Close #ff
        
        tmp = Replace(tmp, s, vbNullString) 'remove "PE header"
        tmp = sDecode(tmp) 'decrypt
        
        SetAttr sFile, vbReadOnly + vbSystem
    End If
    
    For k = 1 To 10
        s = GetToken(tmp, Chr$(1), k)
        HighScores(k).sName = GetToken(s, Chr$(0), 1)
        s = GetToken(s, Chr$(0), 2)
        If IsNumeric(s) Then
            HighScores(k).sScore = CLng(s)
        End If
    Next
    
End Sub
